<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.teowin.nl
 * @since      1.0.0
 *
 * @package    powerall
 * @subpackage powerall/admin/partials
 */


function admin_notices() {
    global $slt_form_submit_messages;

    if ( $slt_form_submit_messages == '' ) {
        return;
    }

    $messages = $slt_form_submit_messages;


    if ( count( $messages ) > 0 ) {
        echo "<div id='notice' class='updated error'><p>" . implode( "</p><p>", $messages ) . "</p></div>";
    }

}

?>



<div class="wrap">

    <h2><?php echo esc_html(get_admin_page_title()); ?></h2>

 <?php

    if (isset($_POST['my_plugin_ajax_submit'])) {
         if ( wp_verify_nonce( $_POST['my_plugin_ajax_submit'], 'my_plugin_ajax_submit' ) ) {

             if (isset($_POST['slt_licence_form_submit'])) {
                 licence_form_submit();
                 do_tabs();
             }
             else if (isset($_POST['slt_licence_form_submit']) && isset($_POST['slt_licence_deactivate'])) {
                 licence_form_submit();
                 do_tabs();
             }
             else {
                 my_plugin_ajax_submit();
             }
         }
    }
    else {

        do_tabs();

    }


function do_tabs(){
    admin_notices();
    $active_tab = 'plugin_settings';
    if ( isset( $_GET['tab'] ) ) {
      $active_tab = $_GET['tab'];
    }

    ?>

    <div class="nav-tab-wrapper">
        <a href="?page=<?php echo $_GET['page']; ?>&tab=plugin_settings" class="nav-tab <?php echo $active_tab == 'plugin_settings' ? 'nav-tab-active' : ''; ?>">Plugin Instellingen</a>
        <a href="?page=<?php echo $_GET['page']; ?>&tab=powerall_settings" class="nav-tab <?php echo $active_tab == 'powerall_settings' ? 'nav-tab-active' : ''; ?>">Powerall Koppeling</a>
        <a href="?page=<?php echo $_GET['page']; ?>&tab=powerall_tax_settings" class="nav-tab <?php echo $active_tab == 'powerall_tax_settings' ? 'nav-tab-active' : ''; ?>">BTW Koppeling</a>
        <a href="?page=<?php echo $_GET['page']; ?>&tab=powerall_pay_settings" class="nav-tab <?php echo $active_tab == 'powerall_pay_settings' ? 'nav-tab-active' : ''; ?>">Betaling Koppeling</a>
        <a href="?page=<?php echo $_GET['page']; ?>&tab=powerall_ship_settings" class="nav-tab <?php echo $active_tab == 'powerall_ship_settings' ? 'nav-tab-active' : ''; ?>">Verzending Koppeling</a>
    </div>

    <?php

	    if ( $active_tab == 'plugin_settings' ) {
            $licence = new Powerall_dropshipment_Licence();

            if ( $licence->licence_key_verify() ) {
               licence_deactivate_form();
            } else {
                licence_form_autosave();
            }



	    } elseif ( $active_tab == 'powerall_settings' ) {
		    do_form();

	    } elseif ( $active_tab == 'powerall_tax_settings' ) {
		    do_tax_form();

	    } elseif ( $active_tab == 'powerall_pay_settings' ) {
		    do_pay_form();

	    } elseif ( $active_tab == 'powerall_ship_settings' ) {
		    do_ship_form();

	    }
    }

 function do_form()
 {
 ?>
    <form method="POST">
		<?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>
        <table class="form-table">
            <tbody>
            <tr>
                <th><label for="powerall_login">Login</label></th>
                <td> <input type="text" id="powerall_login" class="powerall_login regular-text ltr" name="powerall_login" value="<?php echo get_option('powerall_login') ?>"></td>
            </tr>
            <tr>
                <th><label for="powerall_password">Wachtwoord</label></th>
                <td><input type="text" id="powerall_password" class="powerall_password regular-text ltr" name="powerall_password" value="<?php echo get_option('powerall_password') ?>"></td>
            </tr>

            <tr>
                <th><label for="powerall_hash">WebApi Hash</label></th>
                <td><input type="text" id="powerall_hash" class="powerall_hash regular-text ltr" name="powerall_hash" value="<?php echo get_option('powerall_hash') ?>"><a class="button button-secondary" id="hashButton"><?php echo(__('Geneer Token', 'twpw'));?></a>
                </td>
            </tr>

            <tr class="form-field">
                <th scope="row" valign="top"><label for="pw_meta_frompw"><?php _e('Synchronize', 'twpw'); ?></label></th>
                <td>
                    <input type="checkbox" name="powerall_sync" id="powerall_sync" <?php if (esc_attr( get_option('powerall_sync') ) == "on") echo "checked"; ?> />
                    <p class="description"><?php _e('Enable or disable automatic synchronizing', 'twpw'); ?></p>
                </td>
            </tr>

            <tr valign="top">
                <th>Synchroniseer</th>
                <td><a class="button button-secondary" id="syncCustButton">Synchroniseer Klanten</a>
                    <a class="button button-secondary" id="syncProdButton">Synchroniseer Producten</a>
                    <a class="button button-secondary button-disabled" id="syncDiscButton">Synchroniseer Kortingen</a></td>

            </tr>
            </tbody>
        </table>
        <p class="submit">
            <input type="submit" name="submit" id="submit" class="button button-primary" value="Opslaan">
        </p>
    </form>
</div>

<?php }

function do_tax_form()
{
	?>
    <form method="POST">
		<?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>
        <table class="form-table">
            <tbody>
            <tr>
                <th><label for="powerall_hash">BTW koppelingen</label></th>
                <td><?php Powerall_Taxes_link_display();  ?>
                </td>
            </tr>
            </tbody>
        </table>
        <p class="submit">
            <input type="submit" name="submit" id="submit" class="button button-primary" value="Opslaan">
        </p>
    </form>
    </div>

<?php }

function do_pay_form()
{
	?>
    <form method="POST">
		<?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>
        <table class="form-table">
            <tbody>


            <tr>
                <th><label for="powerall_hash">Betaalgateway koppelingen</label></th>
                <td><?php Powerall_Payments_link_display();  ?>
                </td>
            </tr>

            </tbody>
        </table>
        <p class="submit">
            <input type="submit" name="submit" id="submit" class="button button-primary" value="Opslaan">
        </p>
    </form>
    </div>

<?php }

function do_ship_form()
{
	?>
    <br>Koppel de in Powerall ingestelde verzendwijzen aan de Woocommerce verzendwijzen.</br>Voeg minimaal 1 regel toe voor elke verzendwijze in Powerall.</p>
    <form method="POST">
		<?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>


        <table class="form-table">
            <tbody>

            <tr>
                <th><label for="powerall_hash">Verzendwijze koppelingen</label></th>
                <td><?php Powerall_Shipment_link_display();  ?>
                </td>
            </tr>


            </tbody>
        </table>
        <p class="submit">
            <input type="submit" name="submit" id="submit" class="button button-primary" value="Opslaan">
        </p>
    </form>
    </div>

<?php }


function my_plugin_ajax_submit() {



	if (isset($_POST['powerall_login'])) {
		$pw_login = $_POST['powerall_login'];
		update_option('powerall_login', $pw_login);
	} else
    {
        delete_option('powerall_login');
    }

    if (isset($_POST['powerall_password'])) {

	   $pw_password = $_POST['powerall_password'];
	   update_option('powerall_password', $pw_password);
    } else {
        delete_option('powerall_password' );
    }

	if (isset($_POST['powerall_hash'])) {

		$pw_hash= $_POST['powerall_hash'];
		update_option('powerall_hash', $pw_hash);
	} else {
        delete_option('powerall_hash');
    }

    if (isset($_POST['powerall_sync'])) {
        $pw_sync = $_POST['powerall_sync'];
        update_option('powerall_sync', $pw_sync);
    } else {
        update_option('powerall_sync', 'off');
    }


	if (isset($_POST['pwTaxId'])) {
		$new = array();
		$old = get_option('powerall_taxes');

		$pwTaxItems  = $_POST['pwTaxId'];
		$wooTaxItems = $_POST['wooTaxId'];

		$count = count( $pwTaxItems );
		for ( $i = 0; $i < $count; $i ++ ) {
			if ( $pwTaxItems[ $i ] != '' ) :
				$new[ $i ]['pwTaxId']  = stripslashes( strip_tags( $pwTaxItems[ $i ] ) );
				$new[ $i ]['wooTaxId'] = stripslashes( $wooTaxItems[ $i ] );
			endif;
		}
		if ( ! empty( $new ) && $new != $old ) {
			update_option( 'powerall_taxes', $new );
		} elseif ( empty( $new ) && $old ) {
			update_option( 'powerall_taxes', $old );
		}
	}

	if (isset($_POST['pwPayId'])) {
		$new = array();
		$old = get_option('powerall_payment');

		$pwPayItems  = $_POST['pwPayId'];
		$wooPayItems = $_POST['wooPayId'];

		$count = count( $pwPayItems );
		for ( $i = 0; $i < $count; $i ++ ) {
			if ( $pwPayItems[ $i ] != '' ) :
				$new[ $i ]['pwPayId']  = stripslashes( strip_tags( $pwPayItems[ $i ] ) );
				$new[ $i ]['wooPayId'] = stripslashes( $wooPayItems[ $i ] );
			endif;
		}
		if ( ! empty( $new ) && $new != $old ) {
			update_option( 'powerall_payment', $new );
		} elseif ( empty( $new ) && $old ) {
			update_option( 'powerall_payment', $old );
		}
	}

	if (isset($_POST['pwShipId'])) {
		$new = array();
		$old = get_option('powerall_shipment');

		$pwShipItems  = $_POST['pwShipId'];
		$wooShipItems = $_POST['wooShipId'];

		$count = count( $pwShipItems );
		for ( $i = 0; $i < $count; $i ++ ) {
			if ( $pwShipItems[ $i ] != '' ) :
				$new[ $i ]['pwShipId']  = stripslashes( strip_tags( $pwShipItems[ $i ] ) );
				$new[ $i ]['wooShipId'] = stripslashes( $wooShipItems[ $i ] );
			endif;
		}
		if ( ! empty( $new ) && $new != $old ) {
			update_option( 'powerall_shipment', $new );
		} elseif ( empty( $new ) && $old ) {
			update_option( 'powerall_shipment', $old );
		}
	}



?>
	<div class="updated">
        <p>Instellingen opgeslagen!</p>
    </div>

    <?php

	do_tabs();

}

function GetWooTaxesWithSelect($id){
	    $all_tax_rates = [];
	    $tax_classes = WC_Tax::get_tax_classes(); // Retrieve all tax classes.
	    if ( !in_array( '', $tax_classes ) ) { // Make sure "Standard rate" (empty class name) is present.
		    array_unshift( $tax_classes, '' );
	    }
	    foreach ( $tax_classes as $tax_class ) { // For each tax class, get all rates.
		    $taxes = WC_Tax::get_rates_for_tax_class( $tax_class );
		    $all_tax_rates = array_merge( $all_tax_rates, $taxes );
	    }

	    $select_html = '<select class="dropdown" id="wooTaxId[]" name="wooTaxId[]" title="WooCommerce Tax ID">';
	    $selected = '';
	    foreach ($all_tax_rates as $btw){
		    if ( $btw->tax_rate_id  === $id ) {
			    $selected = 'selected="selected';
               }
	     $select_html .=  '<option ' . $selected . ' value="' . $btw->tax_rate_id . '">' . $btw->tax_rate_country . ' '.  $btw->tax_rate_name . '</option>';
       }

	    $select_html .= '</select>';
	    return $select_html;
    }

function GetWooPaymentGatewaysWithSelect($id){
    $gateways = WC()->payment_gateways()->get_available_payment_gateways();


	$select_html = '<select class="dropdown" id="wooPayId[]" name="wooPayId[]" title="WooCommerce Payment ID">';
	$selected = '';

    if ($gateways) {
        foreach($gateways as $gateway) {
            $selected = '';
            if ( $gateway->enabled == 'yes' ) {
                if ( $gateway->id === $id ) {
                    $selected = 'selected="selected';
                }
                $select_html .= '<option ' . $selected . ' value="' . $gateway->id . '">' . $gateway->method_title . '</option>';
            }
        }
    }

	$select_html .= '</select>';
	return $select_html;
}

function GetWooShipmentsWithSelect($id){

	// Get all your existing shipping zones IDS
	$zone_ids = array_keys( array('') + WC_Shipping_Zones::get_zones() );

	$select_html = '<select class="dropdown" id="wooShipId[]" name="wooShipId[]" title="WooCommerce Shipment ID">';
	$selected = '';

// Loop through shipping Zones IDs
	foreach ( $zone_ids as $zone_id )
	{
		// Get the shipping Zone object
		$shipping_zone = new WC_Shipping_Zone($zone_id);

		// Get all shipping method values for the shipping zone
		$shipping_methods = $shipping_zone->get_shipping_methods( true, 'values' );

		$selected = '';

		// Loop through each shipping methods set for the current shipping zone
		foreach ( $shipping_methods as $instance_id => $shipping_method )
		{
			// The dump of protected data from the current shipping method
		   if ( $shipping_method->id  === $id){
			   $selected = 'selected="selected';
           }
			$select_html .= '<option ' . $selected . ' value="' . $shipping_method->id . '">' . $shipping_method->method_title . '</option>';
		}
	}

	$select_html .= '</select>';
	return $select_html;
}

function Powerall_Taxes_link_display() {
	    global $post;

	    $pw_taxes = get_option('powerall_taxes');

		    wp_nonce_field( 'gpm_repeatable_meta_box_nonce', 'gpm_repeatable_meta_box_nonce' );
		    ?>

            <script type="text/javascript">
                jQuery(document).ready(function( $ ){
                    $( '#add-tax-row' ).on('click', function() {
                        var row = $( '.empty-tax-row.screen-reader-text' ).clone(true);
                        row.removeClass( 'empty-row screen-reader-text' );
                        row.insertBefore( '#repeatable-fieldset-one tbody>tr:last' );
                        return false;
                    });

                    $( '.remove-tax-row' ).on('click', function() {
                        $(this).closest("tr").remove();
                        return false;
                    });
                });
            </script>
       <div style="width: 510px; border: 1px solid black; height: auto; padding-left: 20px; padding-bottom: 20px">
            <table id="repeatable-fieldset-one" border="0" width="100%" >
                <thead>
                <tr>
                    <td width="10%">
                       <b>PowerAll ID</b>  </td>
                    <td width="15%">
                       <b>WooCommerce ID</b> </td>

                </tr>
                </thead>
                <tbody>
			    <?php
			    if ( $pw_taxes ) :
				    foreach ( $pw_taxes as $field ) {
					    ?>
                        <tr>
                            <td width="10%">
                                <input type="number" size="8" name="pwTaxId[]" value="<?php if($field['pwTaxId'] != '') echo esc_attr( $field['pwTaxId'] ); ?>" /></td>
                            <td width="15">
                            <?php echo GetWooTaxesWithSelect($field['wooTaxId']);  ?>  </td>
                            <?php if (count($pw_taxes) > 1){ ?>
                            <td width="15%"><a class="button remove-tax-row" href="#1">Verwijder</a></td>
                            <?php } ?>
                        </tr>
					    <?php
				    }
			    else :
				    // show a blank one
				    ?>
                    <tr>
                        <td width="10%">
                            <input type="number" size="8"  name="pwTaxId[]" value="" /></td>
                        <td width="15%">
	                        <?php echo GetWooTaxesWithSelect(0);  ?>  </td>
                        <td width="15%"><a class="button remove-tax-row" href="#">Verwijder</a></td>
                    <?php //   <td><a class="button  cmb-remove-row-button button-disabled" href="#">Verwijder</a></td> ?>
                    </tr>
			    <?php endif; ?>
                <!-- empty hidden one for jQuery -->
                <tr class="empty-tax-row screen-reader-text">
                    <td width="10%">
                        <input type="number" size="8"  name="pwTaxId[]" value="" /></td>
                    <td width="15%">
	                    <?php echo GetWooTaxesWithSelect(0);  ?>  </td>
                    <td width="15%"><a class="button remove-tax-row" href="#">Verwijder</a></td>
                </tbody>
            </table>
            <p><a id="add-tax-row" class="button" href="#">Toevoegen</a></p>
       </div>
            <script>
   //             $('#repeatable-fieldset-one tbody').sortable();
            </script>
		    <?php

    }

function Powerall_Payments_link_display() {
	global $post;

	$pw_payments = get_option('powerall_payment');

	wp_nonce_field( 'gpm_repeatable_meta_box_nonce', 'gpm_repeatable_meta_box_nonce' );
	?>

    <script type="text/javascript">
        jQuery(document).ready(function( $ ){
            $( '#add-pay-row' ).on('click', function() {
                var row = $( '.empty-pay-row.screen-reader-text' ).clone(true);
                row.removeClass( 'empty-pay-row screen-reader-text' );
                row.insertBefore( '#repeatable-fieldset-two tbody>tr:last' );
                return false;
            });

            $( '.remove-pay-row' ).on('click', function() {
                $(this).closest('tr').remove();
                return false;
            });
        });
    </script>
    <div style="width: 510px; border: 1px solid black; height: auto; padding-left: 20px; padding-bottom: 20px">
        <table id="repeatable-fieldset-two" border="0" width="100%" >
            <thead>
            <tr>
                <td width="10%">
                    <b>PowerAll ID</b>  </td>
                <td width="15%">
                    <b>WooCommerce ID</b> </td>

            </tr>
            </thead>
            <tbody>
			<?php
			if ( $pw_payments ) :
				foreach ( $pw_payments as $field ) {
					?>
                    <tr>
                        <td width="10%">
                            <input type="number" size="8" name="pwPayId[]" value="<?php if($field['pwPayId'] != '') echo esc_attr( $field['pwPayId'] ); ?>" /></td>
                        <td width="15">
							<?php echo GetWooPaymentGatewaysWithSelect($field['wooPayId']);  ?>  </td>
						<?php if (count($pw_payments) > 0){ ?>
                            <td width="15%"><a class="button remove-pay-row" href="#1">Verwijder</a></td>
						<?php } ?>
                    </tr>
					<?php
				}
			else :
				// show a blank one
				?>
                <tr>
                    <td width="10%">
                        <input type="number" size="8"  name="pwPayId[]" value="" /></td>
                    <td width="15%">
						<?php echo GetWooPaymentGatewaysWithSelect(0);  ?>  </td>

					<?php //   <td><a class="button  cmb-remove-row-button button-disabled" href="#">Verwijder</a></td> ?>
                </tr>
			<?php endif; ?>
            <!-- empty hidden one for jQuery -->
            <tr class="empty-pay-row screen-reader-text">
                <td width="10%">
                    <input type="number" size="8"  name="pwPayId[]" value="" /></td>
                <td width="15%">
					<?php echo GetWooPaymentGatewaysWithSelect(0);  ?>  </td>
                <td width="15%"><a class="button remove-pay-row" href="#">Verwijder</a></td>
            </tbody>
        </table>
        <p><a id="add-pay-row" class="button" href="#">Toevoegen</a></p>
    </div>
    <script>
   //     $('#repeatable-fieldset-two tbody').sortable();
    </script>
	<?php

}

function Powerall_Shipment_link_display() {
	global $post;

	$pw_shipments = get_option('powerall_shipment');

	wp_nonce_field( 'gpm_repeatable_meta_box_nonce', 'gpm_repeatable_meta_box_nonce' );
	?>

    <script type="text/javascript">
        jQuery(document).ready(function( $ ){
            $( '#add-ship-row' ).on('click', function() {
                var row = $( '.empty-ship-row.screen-reader-text' ).clone(true);
                row.removeClass( 'empty-ship-row screen-reader-text' );
                row.insertBefore( '#repeatable-fieldset-three tbody>tr:last' );
                return false;
            });

            $( '.remove-ship-row' ).on('click', function() {
                $(this).closest('tr').remove();
                return false;
            });
        });
    </script>
    <div style="width: 510px; border: 1px solid black; height: auto; padding-left: 20px; padding-bottom: 20px">
        <table id="repeatable-fieldset-three" border="0" width="100%" >
            <thead>
            <tr>
                <td width="10%">
                    <b>PowerAll ID</b>  </td>
                <td width="15%">
                    <b>WooCommerce ID</b> </td>

            </tr>
            </thead>
            <tbody>
			<?php
			if ( $pw_shipments ) :
				foreach ( $pw_shipments as $field ) {
					?>
                    <tr>
                        <td width="10%">
                            <input type="number" size="8" name="pwShipId[]" value="<?php if($field['pwShipId'] != '') echo esc_attr( $field['pwShipId'] ); ?>" /></td>
                        <td width="15">
							<?php echo GetWooShipmentsWithSelect($field['wooShipId']);  ?>  </td>
						<?php if (count($pw_shipments) > 0){ ?>
                            <td width="15%"><a class="button remove-ship-row" href="#1">Verwijder</a></td>
						<?php } ?>
                    </tr>
					<?php
				}
			else :
				// show a blank one
				?>
                <tr>
                    <td width="10%">
                        <input type="number" size="8"  name="pwShipId[]" value="" /></td>
                    <td width="15%">
						<?php echo GetWooShipmentsWithSelect(0);  ?>  </td>

					<?php //   <td><a class="button  cmb-remove-row-button button-disabled" href="#">Verwijder</a></td> ?>
                </tr>
			<?php endif; ?>
            <!-- empty hidden one for jQuery -->
            <tr class="empty-ship-row screen-reader-text">
                <td width="10%">
                    <input type="number" size="8"  name="pwShipId[]" value="" /></td>
                <td width="15%">
					<?php echo GetWooShipmentsWithSelect(0);  ?>  </td>
                <td width="15%"><a class="button remove-ship-row" href="#">Verwijder</a></td>
            </tbody>
        </table>
        <p><a id="add-ship-row" class="button" href="#">Toevoegen</a></p>
    </div>
    <script>
     //   $('#repeatable-fieldset-tree tbody').sortable();
    </script>
	<?php

}

function licence_form_autosave() {
    ?>
    <div class="wrap">
        <div id="icon-settings" class="icon32"></div>
        <h2><?php _e( "Teowin Powerall Dropshipment License key", 'wooslt' ) ?><br/>&nbsp;</h2>
        <form method="POST">
            <?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>
            <input type="hidden" name="slt_licence_form_submit" value="true"/>
            <table class="form-table">
                <tbody>
                <tr>
                    <th><label for="powerall_productsleutel">Licentiesleutel</label></th>
                    <td><input type="text" value="" name="license_key" class="text-input">
                    </td>
                </tr>
                <tr><td colspan="5"><?php _e( "Enter the License Key you got when bought this product from Teowin. It was sent to you by email.. If you lost the key, you can always retrieve it from", 'wooslt' ) ?>
                        <a href="<?php echo POWERALL_DS_APP_URL ?>/my-account/"
                           target="_blank"><?php _e( "My Account", 'wooslt' ) ?></a><br/>
                        <?php _e( "More keys can be generate from", 'wooslt' ) ?> <a
                                href="<?php echo POWERALL_DS_APP_URL ?>/my-account/"
                                target="_blank"><?php _e( "My Account", 'wooslt' ) ?></a></td> </tr>
                </tbody>
            </table>
            <p class="submit">
                <input type="submit" name="Submit" class="button button-primary"
                       value="<?php _e( 'Save', 'wooslt' ) ?>">
            </p>
        </form>
    </div>
    <?php

}

function licence_form_submit() {
    global $slt_form_submit_messages;

    if (isset(  $_POST['_wp_http_referer '])) {
        $theURL =  $_POST['_wp_http_referer '];
    } else{
        $theURL = 'http' . ( isset( $_SERVER['HTTPS'] ) ? 's' : '' ) . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    }

    //check for de-activation
    if ( isset( $_POST['slt_licence_form_submit'] ) && isset( $_POST['slt_licence_deactivate'] ) && wp_verify_nonce( $_POST['my_plugin_ajax_submit'], 'my_plugin_ajax_submit' ) ) {
        global $slt_form_submit_messages;

        $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );
        $license_key  = $license_data['key'];

        //build the request query
        $args        = array(
            'woo_sl_action'     => 'deactivate',
            'licence_key'       => $license_key,
            'product_unique_id' => POWERALL_DS_PRODUCT_ID,
            'domain'            => POWERALL_DS_INSTANCE
        );
        $request_uri = POWERALL_DS_APP_API_URL . '?' . http_build_query( $args, '', '&' );
        $data        = wp_remote_get( $request_uri );

        //log if debug
        if ( defined( 'WP_DEBUG' ) && WP_DEBUG === true ) {

            POWERALL_DS_license::log_data( "------\nArguments:" );
            POWERALL_DS_license::log_data( $args );

            POWERALL_DS_license::log_data( "\nResponse Body:" );
            POWERALL_DS_license::log_data( $data['body'] );
            POWERALL_DS_license::log_data( "\nResponse Server Response:" );
            POWERALL_DS_license::log_data( $data['response'] );
        }

        if ( is_wp_error( $data ) || $data['response']['code'] != 200 ) {
            $slt_form_submit_messages[] .= __( 'There was a problem connecting to ', 'wooslt' ) . POWERALL_DS_APP_API_URL;

          return;
        }

        $response_block = json_decode( $data['body'] );
        //retrieve the last message within the $response_block
        $response_block = $response_block[ count( $response_block ) - 1 ];
        $response       = $response_block->message;

        if ( isset( $response_block->status ) ) {
            if ( $response_block->status == 'success' && $response_block->status_code == 's201' ) {
                //the license is active and the software is active
                $slt_form_submit_messages[] = $response_block->message;

                $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );

                //save the license
                $license_data['key']        = '';
                $license_data['last_check'] = time();

                update_site_option( POWERALL_DS_PRODUCT_ID, $license_data );


            } else //if message code is e104  force de-activation
                if ( $response_block->status_code == 'e002' || $response_block->status_code == 'e104' ) {
                    $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );

                    //save the license
                    $license_data['key']        = '';
                    $license_data['last_check'] = time();

                    update_site_option( POWERALL_DS_PRODUCT_ID, $license_data );
                } else {

                    $slt_form_submit_messages[] = __( 'There was a problem deactivating the licence: ', 'wooslt' ) . $response_block->message;

             //       wp_redirect($theURL);
             //       wp_die();
                }
        } else {
            $slt_form_submit_messages[] = __( 'There was a problem with the data block received from ' . POWERALL_DS_APP_API_URL, 'wooslt' );

           return;

        }

         return;


    }


    if ( isset( $_POST['slt_licence_form_submit'] ) && wp_verify_nonce( $_POST['my_plugin_ajax_submit'], 'my_plugin_ajax_submit' ) ) {

        $license_key = isset( $_POST['license_key'] ) ? sanitize_key( trim( $_POST['license_key'] ) ) : '';

        if ( $license_key == '' ) {
            $slt_form_submit_messages[] = __( "License Key can't be empty", 'wooslt' );

            return;

        }

        //build the request query
        $args = array(
            'woo_sl_action'     => 'activate',
            'licence_key'       => $license_key,
            'product_unique_id' => POWERALL_DS_PRODUCT_ID,
            'domain'            => POWERALL_DS_INSTANCE
        );
        //         $request_uri    = POWERALL_DS_APP_API_URL . '?' . http_build_query( $args , '', '&');

        $request_uri = POWERALL_DS_APP_API_URL . '?' . http_build_query( $args );

        $data = wp_remote_get( $request_uri );

        //log if debug
        /*       If (defined('WP_DEBUG') &&  WP_DEBUG    === TRUE)
                   {
                       POWERALL_DS::log_data("------\nArguments:");
                       POWERALL_DS::log_data($args);

                       POWERALL_DS::log_data("\nResponse Body:");
                       POWERALL_DS::log_data($data['body']);
                       POWERALL_DS::log_data("\nResponse Server Response:");
                       POWERALL_DS::log_data($data['response']);
                   }
        */

        if ( is_wp_error( $data ) || $data['response']['code'] != 200 ) {
            $slt_form_submit_messages[] .= __( 'There was a problem connecting to ', 'wooslt' ) . POWERALL_DS_APP_API_URL;

            return;

        }

        $response_block = json_decode( $data['body'] );
        //retrieve the last message within the $response_block
        $response_block = $response_block[ count( $response_block ) - 1 ];
        $response       = $response_block->message;

        if ( isset( $response_block->status ) ) {
            if ( $response_block->status == 'success' && $response_block->status_code == 's100' ) {
                //the license is active and the software is active
                $slt_form_submit_messages[] = $response_block->message;

                $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );

                //save the license
                $license_data['key']        = $license_key;
                $license_data['last_check'] = time();

                update_site_option( POWERALL_DS_PRODUCT_ID, $license_data );


            } else if ( $response_block->status == 'success' && $response_block->status_code == 's101' ) {
                //the license is active and the software is active
                $slt_form_submit_messages[] = $response_block->message;

                $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );

                //save the license
                $license_data['key']        = $license_key;
                $license_data['last_check'] = time();

                update_site_option( POWERALL_DS_PRODUCT_ID, $license_data );

            }else {
                $slt_form_submit_messages[] = __( 'There was a problem activating the licence: ', 'wooslt' ) . $response_block->message;



            }
        } else {
            $slt_form_submit_messages[] = __( 'There was a problem with the data block received from ' . POWERALL_DS_APP_API_URL, 'wooslt' );

            return;

        }


        return;

    }

}


function licence_deactivate_form() {
    $license_data = get_site_option( POWERALL_DS_PRODUCT_ID );

    if ( is_multisite() ) {
        ?>
        <div class="wrap">
        <div id="icon-settings" class="icon32"></div>
        <h2><?php _e( "General Settings", 'wooslt' ) ?></h2>
        <?php
    }

    ?>
    <div id="form_data">
        <h2><?php _e( "Teowin Powerall Dropshipment", 'twpw' ) ?></h2>
        <form method="POST">
            <?php wp_nonce_field( 'my_plugin_ajax_submit', 'my_plugin_ajax_submit' ); ?>

                <input type="hidden" name="slt_licence_form_submit" value="true"/>
                <input type="hidden" name="slt_licence_deactivate" value="true"/>
                    <h4 class="heading" style="color: red;"><?php _e( "Teowin Woocommerce-Powerall licentiesleutel is actief:", 'wooslt' ) ?></h4>
                    <table class="form-table">
                        <tbody>
                        <tr>
                            <th><label for="powerall_productsleutel">Licentiesleutel</label></th>
                            <td> <p><b><?php echo substr( $license_data['key'], 0, 20 ) ?>-xxxxxxxx-xxxxxxxx</b>
<!--                                    &nbsp;&nbsp;&nbsp;<a class="button-secondary" title="Deactivate"-->
<!--                                                         href="javascript: void(0)"-->
<!--                                                         onclick="jQuery(this).closest('form').submit();">Deactivate</a>-->
                                    <input type="submit" name="Submit" class="button button-secondary"
                                           value="<?php _e( 'Deactivate', 'wooslt' ) ?>">
                                </p>
                            </td>
                        </tr>
                        </tbody>
                    </table>

                        <div class="explain"><?php _e( "Als de licentie het toelaat, kun je extra licentiesleutels genereren van uit het ", 'wooslt' ) ?> <a
                                    href="<?php echo POWERALL_DS_APP_URL ?>/my-account/" target="_blank">Account op de website van Teowin</a>

            </form>

    </div>
    <?php

    if ( is_multisite() ) {
        ?>
        </div>
        <?php
    }

    display_license();
}

function display_license(){
    ?>
   <div class="explain"><p>Open source is geen freeware! Op deze plugin, code en werking is copyright/auteursrecht van toepassing.
       Een van voorwaarden voor gebruik van onze plugins, is dat u een eigen, geldige licentie heeft. Die licentie heeft u van Teowin ontvangen
       na aankoop en betaling van de overeenkomst voor recht op gebruik, updates en support.
       Heeft u geen (verlopen) licentie dan dient u deze plugin van uw website te verwijderen. Door het installeren en gebruiken van deze plugin, accepteert u deze voorwaarden. </p>
   </div>
   <?php
}



?>


