<?php
/*
Plugin Name:          PowerAll Dropship
Plugin URI:           www.teowin.nl
Description:          PowerAll Dropship is the connection between your Woocommerce website and PowerAll API
Version:              1.1.0
Author:               Teowin
Author URI:           www.teowin.nl
License:              Native commercial
Text Domain:          pw
Domain Path:          /languages
Requires at least:    4.0
Tested up to:         5.7
WC requires at least: 3.0
WC tested up to:      5.1
*/


/*
 * License:			  Deze software is intellectueel eigendom van Teo Super/Teowin en wordt u ter beschikking gesteld tegen een jaarlijkse vergoeding.
 *                    Deze plugin is geen eigendom van Bever en niet aan Bever software gelieerd. Gebruik van deze plugin is alleen toegestaan op voorwaarde 
 *                    dat er met Teowin een abbonnement is afgesloten. Het bewijs van dit abonnement is een licentiesleutel welke door Teowin aan gebruiker is verstrekt.
 *                    Gebruik van deze software geschiedt geheel voor eigen risico. Teowin is niet aansprakelijk voor het niet of niet juist functioneren van deze software,
 *                    voor conflicten met andere plugins en/of voor beschikbaarheid en gebruik van de Bever PowerAll API.
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */


define('POWERALL_DS_PATH',   plugin_dir_path(__FILE__));
define('POWERALL_DS_URL',    plugins_url('', __FILE__));

define('POWERALL_DS_APP_API_URL',  'https://www.teowin-software.nl/index.php');
define('POWERALL_DS_APP_URL',  'https://www.teowin-software.nl');

define('POWERALL_DS_PLUGIN_NAME', 'powerall.php');

define('POWERALL_DS_FULL_NAME', 'powerall/' . POWERALL_DS_PLUGIN_NAME);

//the Software Unique ID as defined within product admin page
define('POWERALL_DS_PRODUCT_ID', 'powerall_ds');

//A code variable constant is required, which is the user application code version. This will be used by API to compare against the new version on shop server.
define('POWERALL_DS_VERSION', '1.1.1');

$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
define('POWERALL_DS_INSTANCE',             str_replace($protocol, "", get_bloginfo('wpurl')));

include(POWERALL_DS_PATH . '/includes/class.wooslt.php');
include(POWERALL_DS_PATH . '/includes/class.licence.php');
include(POWERALL_DS_PATH . '/includes/class.options.php');
include(POWERALL_DS_PATH . '/includes/class.updater.php');

require_once( ABSPATH . '/wp-admin/includes/plugin.php' ) ; 


/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-pw-activator.php
 */
function activate_pw() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-pw-activator.php';
	Pw_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-pw-deactivator.php
 */
function deactivate_pw() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-pw-deactivator.php';
	Pw_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_pw' );
register_deactivation_hook( __FILE__, 'deactivate_pw' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-pw.php';  

    /**
     * Add a notice about woocommerce being needed.
     */
    function display_admin_notice_about_woocommerce($test) {
        echo '<div class="notice notice-error is-dismissible">';
        echo '<p>' . esc_html__( 'Teowin Powerall-Woocommerce plugin requires WooCommerce to be active to work', 'twpw' ) . '</p>';
        echo '</div>';
    }

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_pw() {
     
        if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
           	$pwDropShipment = PwDropShipment::get_instance();
	          $pwDropShipment->run();
        } else {
            add_action( 'admin_notices', 'display_admin_notice_about_woocommerce' );    
            deactivate_plugins(plugin_basename(__FILE__)); 
            return;
        }
        
        



//	global $POWERALL_DS;
//	$POWERALL_DS = new POWERALL_DS_license();


}
run_pw();
